Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4550)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4559)
@@ -1,22 +1,21 @@
 !> @file chemistry_model_mod.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 2017-2020 Leibniz Universitaet Hannover
 ! Copyright 2017-2020 Karlsruhe Institute of Technology
 ! Copyright 2017-2020 Freie Universitaet Berlin
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 !
 ! Current revisions:
@@ -27,18 +26,21 @@
 ! -----------------
 ! $Id$
+! file re-formatted to follow the PALM coding standard
+!
+! 4550 2020-05-29 15:22:13Z raasch
 ! bugfix for reading local restart data
-! 
+!
 ! 4544 2020-05-21 14:43:05Z raasch
 ! conc_av changed from pointer to allocatable array, array spec_conc_av removed
-! 
+!
 ! 4542 2020-05-19 15:45:12Z raasch
 ! redundant if statement removed
-! 
+!
 ! 4535 2020-05-15 12:07:23Z raasch
 ! bugfix for restart data format query
-! 
+!
 ! 4517 2020-05-03 14:29:30Z raasch
 ! added restart with MPI-IO
-! 
+!
 ! 4511 2020-04-30 12:20:40Z raasch
 ! decycling replaced by explicit setting of lateral boundary conditions
@@ -50,37 +52,33 @@
 ! use statement for exchange horiz added,
 ! bugfix for call of exchange horiz 2d
-! 
+!
 ! 4442 2020-03-04 19:21:13Z suehring
-! Change order of dimension in surface array %frac to allow for better 
+! Change order of dimension in surface array %frac to allow for better
 ! vectorization.
 !
 ! 4441 2020-03-04 19:20:35Z suehring
 ! in subroutine chem_init (ECC)
-! - allows different init paths emission data for legacy
-!   mode emission and on-demand mode
-! in subroutine chem_init_internal (ECC)
-! - reads netcdf file only when legacy mode is activated
-!   (i.e., emiss_read_legacy_mode = .TRUE.)
-!   otherwise file is read once at the beginning to obtain
-!   header information, and emission data are extracted on
-!   an on-demand basis
+! - allows different init paths emission data for legacy mode emission and on-demand mode in
+!   subroutine chem_init_internal (ECC)
+! - reads netcdf file only when legacy mode is activated (i.e., emiss_read_legacy_mode = .TRUE.)
+!   otherwise file is read once at the beginning to obtain header information, and emission data
+!   are extracted on an on-demand basis
 !
 ! 4372 2020-01-14 10:20:35Z banzhafs
-! chem_parin : added handler for new namelist item emiss_legacy_read_mode (ECC)
-! added messages
+! chem_parin : added handler for new namelist item emiss_legacy_read_mode (ECC) added messages
 ! CM0465 - legacy read mode selection
 ! CM0466 - legacy read mode force selection
 ! CM0467 - new read mode selection
 !
-! 4370 2020-01-10 14:00:44Z raasch 
+! 4370 2020-01-10 14:00:44Z raasch
 ! vector directives added to force vectorization on Intel19 compiler
 !
 ! 4346 2019-12-18 11:55:56Z motisi
-! Introduction of wall_flags_total_0, which currently sets bits based on static
-! topography information used in wall_flags_static_0
-! 
+! Introduction of wall_flags_total_0, which currently sets bits based on static topography
+! information used in wall_flags_static_0
+!
 ! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
-! 
+!
 ! 4306 2019-11-25 12:04:48Z banzhafs
 ! Corretion for r4304 commit
@@ -96,83 +94,75 @@
 !
 ! 4273 2019-10-24 13:40:54Z monakurppa
-! Add logical switches nesting_chem and nesting_offline_chem (both .TRUE.
-! by default)
-! 
+! Add logical switches nesting_chem and nesting_offline_chem (both .TRUE. by default)
+!
 ! 4272 2019-10-23 15:18:57Z schwenkel
-! Further modularization of boundary conditions: moved boundary conditions to
-! respective modules
+! Further modularization of boundary conditions: moved boundary conditions to respective modules
 !
 ! 4268 2019-10-17 11:29:38Z schwenkel
 ! Moving module specific boundary conditions from time_integration to module
-! 
+!
 ! 4230 2019-09-11 13:58:14Z suehring
-! Bugfix, initialize mean profiles also in restart runs. Also initialize 
-! array used for Runge-Kutta tendecies in restart runs.  
-! 
+! Bugfix, initialize mean profiles also in restart runs. Also initialize array used for Runge-Kutta
+! tendecies in restart runs.
+!
 ! 4227 2019-09-10 18:04:34Z gronemeier
 ! implement new palm_date_time_mod
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4167 2019-08-16 11:01:48Z suehring
-! Changed behaviour of masked output over surface to follow terrain and ignore 
-! buildings (J.Resler, T.Gronemeier)
-! 
-! 
+! Changed behaviour of masked output over surface to follow terrain and ignore buildings
+! (J.Resler, T.Gronemeier)
+!
 ! 4166 2019-08-16 07:54:21Z resler
 ! Bugfix in decycling
-! 
+!
 ! 4115 2019-07-24 12:50:49Z suehring
 ! Fix faulty IF statement in decycling initialization
-! 
+!
 ! 4110 2019-07-22 17:05:21Z suehring
-! - Decycling boundary conditions are only set at the ghost points not on the
-!   prognostic grid points 
-! - Allocation and initialization of special advection flags cs_advc_flags_s
-!   used for chemistry. These are exclusively used for chemical species in 
-!   order to distinguish from the usually-used flags which might be different
-!   when decycling is applied in combination with cyclic boundary conditions. 
-!   Moreover, cs_advc_flags_s considers extended zones around buildings where 
-!   first-order upwind scheme is applied for the horizontal advection terms, 
-!   in order to overcome high concentration peaks due to stationary numerical 
-!   oscillations caused by horizontal advection discretization.
-! 
+! - Decycling boundary conditions are only set at the ghost points not on the prognostic grid points
+! - Allocation and initialization of special advection flags cs_advc_flags_s used for chemistry.
+!   These are exclusively used for chemical species in order to distinguish from the usually-used
+!   flags which might be different when decycling is applied in combination with cyclic boundary
+!   conditions.
+!   Moreover, cs_advc_flags_s considers extended zones around buildings where first-order upwind
+!   scheme is applied for the horizontal advection terms, in order to overcome high concentration
+!   peaks due to stationary numerical oscillations caused by horizontal advection discretization.
+!
 ! 4109 2019-07-22 17:00:34Z suehring
-! Slightly revise setting of boundary conditions at horizontal walls, use 
-! data-structure offset index instead of pre-calculate it for each facing
-! 
+! Slightly revise setting of boundary conditions at horizontal walls, use data-structure offset
+! index instead of pre-calculate it for each facing
+!
 ! 4080 2019-07-09 18:17:37Z suehring
 ! Restore accidantly removed limitation to positive values
-! 
+!
 ! 4079 2019-07-09 18:04:41Z suehring
-! Application of monotonic flux limiter for the vertical scalar advection 
-! up to the topography top (only for the cache-optimized version at the 
-! moment).
-! 
+! Application of monotonic flux limiter for the vertical scalar advection up to the topography top
+! (only for the cache-optimized version at the moment).
+!
 ! 4069 2019-07-01 14:05:51Z Giersch
-! Masked output running index mid has been introduced as a local variable to 
-! avoid runtime error (Loop variable has been modified) in time_integration
-! 
+! Masked output running index mid has been introduced as a local variable to avoid runtime error
+! (Loop variable has been modified) in time_integration
+!
 ! 4029 2019-06-14 14:04:35Z raasch
 ! nest_chemistry option removed
-! 
+!
 ! 4004 2019-05-24 11:32:38Z suehring
-! in subroutine chem_parin check emiss_lod / mod_emis only
-! when emissions_anthropogenic is activated in namelist (E.C. Chan)
-! 
+! in subroutine chem_parin check emiss_lod / mod_emis only when emissions_anthropogenic is activated
+! in namelist (E.C. Chan)
+!
 ! 3968 2019-05-13 11:04:01Z suehring
-! - added "emiss_lod" which serves the same function as "mode_emis"
-!   both will be synchronized with emiss_lod having pirority over
-!   mode_emis (see informational messages)
+! - added "emiss_lod" which serves the same function as "mode_emis" both will be synchronized with
+!   emiss_lod having pirority over mode_emis (see informational messages)
 ! - modified existing error message and introduced new informational messages
 !    - CM0436 - now also applies to invalid LOD settings
 !    - CM0463 - emiss_lod take precedence in case of conflict with mod_emis
 !    - CM0464 - emiss_lod valued assigned based on mode_emis if undefined
-! 
+!
 ! 3930 2019-04-24 14:57:18Z forkel
 ! Changed chem_non_transport_physics to chem_non_advective_processes
-! 
-! 
+!
 ! 3929 2019-04-24 12:52:08Z banzhafs
 ! Correct/complete module_interface introduction for chemistry model
@@ -182,13 +172,13 @@
 ! 3784 2019-03-05 14:16:20Z banzhafs
 ! 2D output of emission fluxes
-! 
+!
 ! 3784 2019-03-05 14:16:20Z banzhafs
-! Bugfix, uncomment erroneous commented variable used for dry deposition. 
-! Bugfix in 3D emission output. 
-! 
+! Bugfix, uncomment erroneous commented variable used for dry deposition.
+! Bugfix in 3D emission output.
+!
 ! 3784 2019-03-05 14:16:20Z banzhafs
-! Changes related to global restructuring of location messages and introduction 
+! Changes related to global restructuring of location messages and introduction
 ! of additional debug messages
-! 
+!
 ! 3784 2019-03-05 14:16:20Z banzhafs
 ! some formatting of the deposition code
@@ -196,60 +186,55 @@
 ! 3784 2019-03-05 14:16:20Z banzhafs
 ! some formatting
-! 
+!
 ! 3784 2019-03-05 14:16:20Z banzhafs
-! added cs_mech to USE chem_gasphase_mod 
-! 
+! added cs_mech to USE chem_gasphase_mod
+!
 ! 3784 2019-03-05 14:16:20Z banzhafs
 ! renamed get_mechanismname to get_mechanism_name
 ! renamed do_emiss to emissions_anthropogenic and do_depo to deposition_dry (ecc)
-! 
+!
 ! 3784 2019-03-05 14:16:20Z banzhafs
 ! Unused variables removed/taken care of
-! 
 !
 ! 3784 2019-03-05 14:16:20Z forkel
 ! Replaced READ from unit 10 by CALL get_mechanismname also in chem_header
 !
-!
 ! 3783 2019-03-05 13:23:50Z forkel
-! Removed forgotte write statements an some unused variables (did not touch the 
-! parts related to deposition)
-! 
-! 
+! Removed forgotte write statements an some unused variables (did not touch the parts related to
+! deposition)
+!
 ! 3780 2019-03-05 11:19:45Z forkel
 ! Removed READ from unit 10, added CALL get_mechanismname
-! 
-! 
+!
 ! 3767 2019-02-27 08:18:02Z raasch
 ! unused variable for file index removed from rrd-subroutines parameter list
-! 
+!
 ! 3738 2019-02-12 17:00:45Z suehring
 ! Clean-up debug prints
-! 
+!
 ! 3737 2019-02-12 16:57:06Z suehring
-! Enable mesoscale offline nesting for chemistry variables as well as 
-! initialization of chemistry via dynamic input file.
-! 
+! Enable mesoscale offline nesting for chemistry variables as well as initialization of chemistry
+! via dynamic input file.
+!
 ! 3719 2019-02-06 13:10:18Z kanani
-! Resolved cpu logpoint overlap with all progn.equations, moved cpu_log call
-! to prognostic_equations for better overview
-! 
+! Resolved cpu logpoint overlap with all progn.equations, moved cpu_log call to prognostic_equations
+! for better overview
+!
 ! 3700 2019-01-26 17:03:42Z knoop
 ! Some interface calls moved to module_interface + cleanup
-! 
+!
 ! 3664 2019-01-09 14:00:37Z forkel
 ! Replaced misplaced location message by @todo
-! 
-! 
+!
 ! 3654 2019-01-07 16:31:57Z suehring
 ! Disable misplaced location message
-! 
+!
 ! 3652 2019-01-07 15:29:59Z forkel
 ! Checks added for chemistry mechanism, parameter chem_mechanism added (basit)
-! 
+!
 ! 2718 2018-01-02 08:49:38Z maronga
 ! Initial revision
 !
-! 
+!
 !
 !
@@ -263,5 +248,5 @@
 !
 !
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
@@ -269,18 +254,17 @@
 !> @todo Extend chem_species type by nspec and nvar as addititional elements (RF)
 !> @todo Check possibility to reduce dimension of chem_species%conc from nspec to nvar (RF)
-!> @todo Adjust chem_rrd_local to CASE structure of others modules. It is not 
-!>       allowed to use the chemistry model in a precursor run and additionally 
-!>       not using it in a main run
+!> @todo Adjust chem_rrd_local to CASE structure of others modules. It is not allowed to use the
+!>       chemistry model in a precursor run and additionally not using it in a main run
 !> @todo Implement turbulent inflow of chem spcs in inflow_turbulence.
 !> @todo Separate boundary conditions for each chem spcs to be implemented
-!> @todo Currently only total concentration are calculated. Resolved, parameterized
-!>       and chemistry fluxes although partially and some completely coded but
-!>       are not operational/activated in this version. bK.
-!> @todo slight differences in passive scalar and chem spcs when chem reactions
-!>       turned off. Need to be fixed. bK
+!> @todo Currently only total concentration are calculated. Resolved, parameterized and chemistry
+!>       fluxes although partially and some completely coded but are not operational/activated in
+!>       this version. bK.
+!> @todo slight differences in passive scalar and chem spcs when chem reactions turned off. Need to
+!>       be fixed. bK
 !> @todo test nesting for chem spcs, was implemented by suehring (kanani)
 !> @todo chemistry error messages
-! 
-!------------------------------------------------------------------------------!
+!
+!--------------------------------------------------------------------------------------------------!
 
  MODULE chemistry_model_mod
@@ -313,5 +297,5 @@
 
     USE control_parameters,                                                                        &
-         ONLY:  bc_lr_cyc, bc_ns_cyc,                                                              &
+         ONLY:  air_chemistry,                                                                     &
                 bc_dirichlet_l,                                                                    &
                 bc_dirichlet_n,                                                                    &
@@ -319,15 +303,25 @@
                 bc_dirichlet_s,                                                                    &
                 bc_radiation_l,                                                                    &
+                bc_lr_cyc,                                                                         &
+                bc_ns_cyc,                                                                         &
                 bc_radiation_n,                                                                    &
                 bc_radiation_r,                                                                    &
                 bc_radiation_s,                                                                    &
                 debug_output,                                                                      &
-                dt_3d, humidity, initializing_actions, message_string,                             &
-                omega, tsc, intermediate_timestep_count, intermediate_timestep_count_max,          &
+                dt_3d,                                                                             &
+                humidity,                                                                          &
+                initializing_actions,                                                              &
+                intermediate_timestep_count,                                                       &
+                intermediate_timestep_count_max,                                                   &
                 max_pr_user,                                                                       &
+                message_string,                                                                    &
                 monotonic_limiter_z,                                                               &
+                omega,                                                                             &
                 restart_data_format_output,                                                        &
                 scalar_advec,                                                                      &
-                timestep_scheme, use_prescribed_profile_data, ws_scheme_sca, air_chemistry
+                timestep_scheme,                                                                   &
+                tsc,                                                                               &
+                use_prescribed_profile_data,                                                       &
+                ws_scheme_sca
 
     USE arrays_3d,                                                                                 &
@@ -359,39 +353,41 @@
     SAVE
 
+    INTEGER, DIMENSION(nkppctrl)                           ::  icntrl       !< 20 integer parameters for fine tuning KPP code
+
+    REAL(kind=wp), PUBLIC ::  cs_time_step = 0._wp
+
+    REAL(kind=wp), DIMENSION(nkppctrl)                     ::  rcntrl       !< 20 real parameters for fine tuning of KPP code
+                                                                            !< (e.g starting internal timestep of solver)
+
     REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_1  !< pointer for swapping of timelevels for conc
     REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_2  !< pointer for swapping of timelevels for conc
     REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  spec_conc_3  !< pointer for swapping of timelevels for conc
-    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  freq_1       !< pointer for phtolysis frequncies 
+    REAL(kind=wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  freq_1       !< pointer for phtolysis frequncies
                                                                             !< (only 1 timelevel required)
-    INTEGER, DIMENSION(nkppctrl)                           ::  icntrl       !< 20 integer parameters for fine tuning KPP code
                                                                             !< (e.g. solver type)
-    REAL(kind=wp), DIMENSION(nkppctrl)                     ::  rcntrl       !< 20 real parameters for fine tuning of KPP code
-                                                                            !< (e.g starting internal timestep of solver)
-
-    REAL(kind=wp), PUBLIC ::  cs_time_step = 0._wp
+
 
 !
 !-- Parameter needed for Deposition calculation using DEPAC model (van Zanten et al., 2010)
-    !
-    INTEGER(iwp), PARAMETER ::  nlu_dep = 15                   !< Number of DEPAC landuse classes (lu's)
-    INTEGER(iwp), PARAMETER ::  ncmp = 10                      !< Number of DEPAC gas components
-    INTEGER(iwp), PARAMETER ::  nposp = 69                     !< Number of possible species for deposition
-!
-!-- DEPAC landuse classes as defined in LOTOS-EUROS model v2.1                              
-    INTEGER(iwp) ::  ilu_grass              = 1        
-    INTEGER(iwp) ::  ilu_arable             = 2        
-    INTEGER(iwp) ::  ilu_permanent_crops    = 3         
-    INTEGER(iwp) ::  ilu_coniferous_forest  = 4         
-    INTEGER(iwp) ::  ilu_deciduous_forest   = 5         
-    INTEGER(iwp) ::  ilu_water_sea          = 6        
-    INTEGER(iwp) ::  ilu_urban              = 7        
-    INTEGER(iwp) ::  ilu_other              = 8  
-    INTEGER(iwp) ::  ilu_desert             = 9  
-    INTEGER(iwp) ::  ilu_ice                = 10 
-    INTEGER(iwp) ::  ilu_savanna            = 11 
-    INTEGER(iwp) ::  ilu_tropical_forest    = 12 
-    INTEGER(iwp) ::  ilu_water_inland       = 13 
-    INTEGER(iwp) ::  ilu_mediterrean_scrub  = 14 
-    INTEGER(iwp) ::  ilu_semi_natural_veg   = 15 
+    INTEGER(iwp), PARAMETER ::  nlu_dep = 15            !< Number of DEPAC landuse classes (lu's)
+    INTEGER(iwp), PARAMETER ::  ncmp = 10               !< Number of DEPAC gas components
+    INTEGER(iwp), PARAMETER ::  nposp = 69              !< Number of possible species for deposition
+!
+!-- DEPAC landuse classes as defined in LOTOS-EUROS model v2.1
+    INTEGER(iwp) ::  ilu_grass              = 1
+    INTEGER(iwp) ::  ilu_arable             = 2
+    INTEGER(iwp) ::  ilu_permanent_crops    = 3
+    INTEGER(iwp) ::  ilu_coniferous_forest  = 4
+    INTEGER(iwp) ::  ilu_deciduous_forest   = 5
+    INTEGER(iwp) ::  ilu_water_sea          = 6
+    INTEGER(iwp) ::  ilu_urban              = 7
+    INTEGER(iwp) ::  ilu_other              = 8
+    INTEGER(iwp) ::  ilu_desert             = 9
+    INTEGER(iwp) ::  ilu_ice                = 10
+    INTEGER(iwp) ::  ilu_savanna            = 11
+    INTEGER(iwp) ::  ilu_tropical_forest    = 12
+    INTEGER(iwp) ::  ilu_water_inland       = 13
+    INTEGER(iwp) ::  ilu_mediterrean_scrub  = 14
+    INTEGER(iwp) ::  ilu_semi_natural_veg   = 15
 
 !
@@ -405,30 +401,30 @@
 !
 !-- Set alpha for f_light (4.57 is conversion factor from 1./(mumol m-2 s-1) to W m-2
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  alpha   =(/ 0.009, 0.009, 0.009, 0.006, 0.006, -999., -999., 0.009, -999.,      &
-         -999., 0.009, 0.006, -999., 0.009, 0.008/)*4.57
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  alpha   = (/ 0.009, 0.009, 0.009, 0.006, 0.006,    &
+                    -999.0, -999., 0.009, -999.0, -999.0, 0.009, 0.006, -999.0, 0.009, 0.008 /)*4.57
 !
 !-- Set temperatures per land use for f_temp
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  tmin = (/ 12.0, 12.0,  12.0,  0.0,  0.0, -999., -999., 12.0, -999., -999.,      &
-         12.0,  0.0, -999., 12.0,  8.0/)
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  topt = (/ 26.0, 26.0,  26.0, 18.0, 20.0, -999., -999., 26.0, -999., -999.,      &
-         26.0, 20.0, -999., 26.0, 24.0 /)
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  tmax = (/ 40.0, 40.0,  40.0, 36.0, 35.0, -999., -999., 40.0, -999., -999.,      &
-         40.0, 35.0, -999., 40.0, 39.0 /)
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  tmin = (/ 12.0,  12.0,  12.0,  0.0,  0.0, -999.0,  &
+                                      -999.0, 12.0, -999.0, -999.0, 12.0,  0.0, -999.0, 12.0,  8.0/)
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  topt = (/ 26.0, 26.0,  26.0, 18.0, 20.0, -999.0,   &
+                                     -999.0, 26.0, -999.0, -999.0, 26.0, 20.0, -999.0, 26.0, 24.0 /)
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  tmax = (/ 40.0, 40.0,  40.0, 36.0, 35.0, -999.0,   &
+                                    -999.0, 40.0, -999.0, -999.0,  40.0, 35.0, -999.0, 40.0, 39.0 /)
 !
 !-- Set f_min:
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  f_min = (/ 0.01, 0.01, 0.01, 0.1, 0.1, -999., -999., 0.01, -999., -999., 0.01,  &
-         0.1, -999., 0.01, 0.04/)
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  f_min = (/ 0.01, 0.01, 0.01, 0.1, 0.1, -999.0,     &
+                                       -999.0, 0.01, -999.0, -999.0, 0.01, 0.1, -999.0, 0.01, 0.04/)
 
 !
 !-- Set maximal conductance (m/s)
 !-- (R T/P) = 1/41000 mmol/m3 is given for 20 deg C to go from  mmol O3/m2/s to m/s
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  g_max = (/ 270., 300., 300., 140., 150., -999., -999., 270., -999., -999.,      &
-         270., 150., -999., 300., 422./)/41000.
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  g_max = (/ 270.0, 300.0, 300.0, 140.0, 150.0,      &
+              -999.0, -999.0, 270.0, -999.0, -999.0, 270.0, 150.0, -999.0, 300.0, 422.0 /) / 41000.0
 !
 !-- Set max, min for vapour pressure deficit vpd
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  vpd_max = (/1.3, 0.9, 0.9, 0.5, 1.0, -999., -999., 1.3, -999., -999., 1.3,      &
-         1.0, -999., 0.9, 2.8/) 
-    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  vpd_min = (/3.0, 2.8, 2.8, 3.0, 3.25, -999., -999., 3.0, -999., -999., 3.0,     &
-         3.25, -999., 2.8, 4.5/) 
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  vpd_max = (/ 1.3, 0.9, 0.9, 0.5, 1.0, -999.0,      &
+                                           -999.0, 1.3, -999.0, -999.0, 1.3, 1.0, -999.0, 0.9, 2.8/)
+    REAL(wp), DIMENSION(nlu_dep), PARAMETER ::  vpd_min = (/ 3.0, 2.8, 2.8, 3.0, 3.25, -999.0,     &
+                                         -999.0, 3.0, -999.0, -999.0, 3.0,  3.25, -999.0, 2.8, 4.5/)
 
     PUBLIC nreact
@@ -436,9 +432,9 @@
     PUBLIC nvar                !< number of variable gas phase chemical species (nvar <= nspec)
     PUBLIC spc_names           !< names of gas phase chemical species (come from KPP) (come from KPP)
-    PUBLIC spec_conc_2  
-!    
+    PUBLIC spec_conc_2
+!
 !-- Interface section
     INTERFACE chem_3d_data_averaging
-       MODULE PROCEDURE chem_3d_data_averaging 
+       MODULE PROCEDURE chem_3d_data_averaging
     END INTERFACE chem_3d_data_averaging
 
@@ -508,8 +504,8 @@
        MODULE PROCEDURE chem_non_advective_processes_ij
     END INTERFACE chem_non_advective_processes
-    
+
     INTERFACE chem_exchange_horiz_bounds
        MODULE PROCEDURE chem_exchange_horiz_bounds
-    END INTERFACE chem_exchange_horiz_bounds    
+    END INTERFACE chem_exchange_horiz_bounds
 
     INTERFACE chem_prognostic_equations
@@ -532,65 +528,65 @@
 
     INTERFACE chem_wrd_local
-       MODULE PROCEDURE chem_wrd_local 
+       MODULE PROCEDURE chem_wrd_local
     END INTERFACE chem_wrd_local
 
     INTERFACE chem_depo
-       MODULE PROCEDURE chem_depo 
+       MODULE PROCEDURE chem_depo
     END INTERFACE chem_depo
 
     INTERFACE drydepos_gas_depac
-       MODULE PROCEDURE drydepos_gas_depac 
+       MODULE PROCEDURE drydepos_gas_depac
     END INTERFACE drydepos_gas_depac
 
     INTERFACE rc_special
-       MODULE PROCEDURE rc_special 
+       MODULE PROCEDURE rc_special
     END INTERFACE rc_special
 
     INTERFACE  rc_gw
-       MODULE PROCEDURE rc_gw 
+       MODULE PROCEDURE rc_gw
     END INTERFACE rc_gw
 
-    INTERFACE rw_so2 
-       MODULE PROCEDURE rw_so2  
+    INTERFACE rw_so2
+       MODULE PROCEDURE rw_so2
     END INTERFACE rw_so2
 
     INTERFACE rw_nh3_sutton
-       MODULE PROCEDURE rw_nh3_sutton 
+       MODULE PROCEDURE rw_nh3_sutton
     END INTERFACE rw_nh3_sutton
 
     INTERFACE rw_constant
-       MODULE PROCEDURE rw_constant 
+       MODULE PROCEDURE rw_constant
     END INTERFACE rw_constant
 
     INTERFACE rc_gstom
-       MODULE PROCEDURE rc_gstom 
+       MODULE PROCEDURE rc_gstom
     END INTERFACE rc_gstom
 
     INTERFACE rc_gstom_emb
-       MODULE PROCEDURE rc_gstom_emb 
+       MODULE PROCEDURE rc_gstom_emb
     END INTERFACE rc_gstom_emb
 
     INTERFACE par_dir_diff
-       MODULE PROCEDURE par_dir_diff 
+       MODULE PROCEDURE par_dir_diff
     END INTERFACE par_dir_diff
 
     INTERFACE rc_get_vpd
-       MODULE PROCEDURE rc_get_vpd 
+       MODULE PROCEDURE rc_get_vpd
     END INTERFACE rc_get_vpd
 
     INTERFACE rc_gsoil_eff
-       MODULE PROCEDURE rc_gsoil_eff 
+       MODULE PROCEDURE rc_gsoil_eff
     END INTERFACE rc_gsoil_eff
 
     INTERFACE rc_rinc
-       MODULE PROCEDURE rc_rinc 
+       MODULE PROCEDURE rc_rinc
     END INTERFACE rc_rinc
 
     INTERFACE rc_rctot
-       MODULE PROCEDURE rc_rctot  
+       MODULE PROCEDURE rc_rctot
     END INTERFACE rc_rctot
 
     INTERFACE drydepo_aero_zhang_vd
-       MODULE PROCEDURE drydepo_aero_zhang_vd 
+       MODULE PROCEDURE drydepo_aero_zhang_vd
     END INTERFACE drydepo_aero_zhang_vd
 
@@ -612,25 +608,24 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Subroutine for averaging 3D data of chemical species. Due to the fact that 
-!> the averaged chem arrays are allocated in chem_init, no if-query concerning
-!> the allocation is required (in any mode). Attention: If you just specify an 
-!> averaged output quantity in the _p3dr file during restarts the first output
-!> includes the time between the beginning of the restart run and the first
-!> output time (not necessarily the whole averaging_interval you have 
-!> specified in your _p3d/_p3dr file )
-!------------------------------------------------------------------------------!
+!> Subroutine for averaging 3D data of chemical species. Due to the fact that the averaged chem
+!> arrays are allocated in chem_init, no if-query concerning the allocation is required (in any
+!> mode). Attention: If you just specify an averaged output quantity in the _p3dr file during
+!> restarts the first output includes the time between the beginning of the restart run and the
+!> first output time (not necessarily the whole averaging_interval you have specified in your
+!> _p3d/_p3dr file ).
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE chem_3d_data_averaging( mode, variable )
 
     USE control_parameters
 
-    USE exchange_horiz_mod,                                                    &
+    USE exchange_horiz_mod,                                                                        &
         ONLY:  exchange_horiz_2d
 
 
-    CHARACTER (LEN=*) ::  mode     !< 
-    CHARACTER (LEN=*) ::  variable !< 
+    CHARACTER (LEN=*) ::  mode     !<
+    CHARACTER (LEN=*) ::  variable !<
 
     LOGICAL ::  match_def  !< flag indicating default-type surface
